<template>
  <div>
    <h2 id="page-heading" data-cy="BoutiqueHeading">
      <span v-text="$t('coopcycleApp.boutique.home.title')" id="boutique-heading">Boutiques</span>
      <div class="d-flex justify-content-end">
        <button class="btn btn-info mr-2" v-on:click="handleSyncList" :disabled="isFetching">
          <font-awesome-icon icon="sync" :spin="isFetching"></font-awesome-icon>
          <span v-text="$t('coopcycleApp.boutique.home.refreshListLabel')">Refresh List</span>
        </button>
        <router-link :to="{ name: 'BoutiqueCreate' }" custom v-slot="{ navigate }">
          <button
            @click="navigate"
            id="jh-create-entity"
            data-cy="entityCreateButton"
            class="btn btn-primary jh-create-entity create-boutique"
          >
            <font-awesome-icon icon="plus"></font-awesome-icon>
            <span v-text="$t('coopcycleApp.boutique.home.createLabel')"> Create a new Boutique </span>
          </button>
        </router-link>
      </div>
    </h2>
    <br />
    <div class="alert alert-warning" v-if="!isFetching && boutiques && boutiques.length === 0">
      <span v-text="$t('coopcycleApp.boutique.home.notFound')">No boutiques found</span>
    </div>
    <div class="table-responsive" v-if="boutiques && boutiques.length > 0">
      <table class="table table-striped" aria-describedby="boutiques">
        <thead>
          <tr>
            <th scope="row" v-on:click="changeOrder('id')">
              <span v-text="$t('global.field.id')">ID</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'id'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('idBoutique')">
              <span v-text="$t('coopcycleApp.boutique.idBoutique')">Id Boutique</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'idBoutique'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('produit.id')">
              <span v-text="$t('coopcycleApp.boutique.produit')">Produit</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'produit.id'"></jhi-sort-indicator>
            </th>
            <th scope="row"></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="boutique in boutiques" :key="boutique.id" data-cy="entityTable">
            <td>
              <router-link :to="{ name: 'BoutiqueView', params: { boutiqueId: boutique.id } }">{{ boutique.id }}</router-link>
            </td>
            <td>{{ boutique.idBoutique }}</td>
            <td>
              <div v-if="boutique.produit">
                <router-link :to="{ name: 'ProduitView', params: { produitId: boutique.produit.id } }">{{
                  boutique.produit.id
                }}</router-link>
              </div>
            </td>
            <td class="text-right">
              <div class="btn-group">
                <router-link :to="{ name: 'BoutiqueView', params: { boutiqueId: boutique.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-info btn-sm details" data-cy="entityDetailsButton">
                    <font-awesome-icon icon="eye"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.view')">View</span>
                  </button>
                </router-link>
                <router-link :to="{ name: 'BoutiqueEdit', params: { boutiqueId: boutique.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-primary btn-sm edit" data-cy="entityEditButton">
                    <font-awesome-icon icon="pencil-alt"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.edit')">Edit</span>
                  </button>
                </router-link>
                <b-button
                  v-on:click="prepareRemove(boutique)"
                  variant="danger"
                  class="btn btn-sm"
                  data-cy="entityDeleteButton"
                  v-b-modal.removeEntity
                >
                  <font-awesome-icon icon="times"></font-awesome-icon>
                  <span class="d-none d-md-inline" v-text="$t('entity.action.delete')">Delete</span>
                </b-button>
              </div>
            </td>
          </tr>
        </tbody>
        <infinite-loading
          ref="infiniteLoading"
          v-if="totalItems > itemsPerPage"
          :identifier="infiniteId"
          slot="append"
          @infinite="loadMore"
          force-use-infinite-wrapper=".el-table__body-wrapper"
          :distance="20"
        >
        </infinite-loading>
      </table>
    </div>
    <b-modal ref="removeEntity" id="removeEntity">
      <span slot="modal-title"
        ><span id="coopcycleApp.boutique.delete.question" data-cy="boutiqueDeleteDialogHeading" v-text="$t('entity.delete.title')"
          >Confirm delete operation</span
        ></span
      >
      <div class="modal-body">
        <p id="jhi-delete-boutique-heading" v-text="$t('coopcycleApp.boutique.delete.question', { id: removeId })">
          Are you sure you want to delete this Boutique?
        </p>
      </div>
      <div slot="modal-footer">
        <button type="button" class="btn btn-secondary" v-text="$t('entity.action.cancel')" v-on:click="closeDialog()">Cancel</button>
        <button
          type="button"
          class="btn btn-primary"
          id="jhi-confirm-delete-boutique"
          data-cy="entityConfirmDeleteButton"
          v-text="$t('entity.action.delete')"
          v-on:click="removeBoutique()"
        >
          Delete
        </button>
      </div>
    </b-modal>
  </div>
</template>

<script lang="ts" src="./boutique.component.ts"></script>
